import 'package:flutter_custom_toolbox/flutter_toolbox.dart';

import 'package:tetrisdual/config/default_activity_settings.dart';

class ActivitySettings {
  final String gameType;

  ActivitySettings({
    required this.gameType,
  });

  static String getGameTypeValueFromUnsafe(String gameType) {
    if (DefaultActivitySettings.allowedGameTypeValues.contains(gameType)) {
      return gameType;
    }

    return DefaultActivitySettings.defaultGameTypeValue;
  }

  factory ActivitySettings.createDefault() {
    return ActivitySettings(
      gameType: DefaultActivitySettings.defaultGameTypeValue,
    );
  }

  void dump() {
    printlog('$ActivitySettings:');
    printlog('  ${DefaultActivitySettings.parameterCodeGameType}: $gameType');
    printlog('');
  }

  @override
  String toString() {
    return '$ActivitySettings(${toJson()})';
  }

  Map<String, dynamic>? toJson() {
    return <String, dynamic>{
      DefaultActivitySettings.parameterCodeGameType: gameType,
    };
  }
}
